package ee.eki.news;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Date;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.PowerManager;
import android.text.format.DateUtils;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

public class EKINewsActivity extends Activity implements
		SharedPreferences.OnSharedPreferenceChangeListener {

	private Handler handler = new Handler();

	SharedPreferences prefs;
	MediaPlayer mediaPlayer;

	ProgressBar progressBar;
	TextView textView;
	ListView listView;

	UDBh dBh;

	PowerManager.WakeLock wl;

	// Button n;
	boolean playing = true;
	boolean playNext = true;
	boolean downloading = true;

	// setungid
	int pref_jarg = 1;
	String pref_v = "1";
	String pref_s = "1";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		//
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
		wl = pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK, "EKINews");
		wl.setReferenceCounted(false);
		// laeb seaded
		prefs = getSharedPreferences("ekinews", 0);
		prefs.registerOnSharedPreferenceChangeListener(this);
		onSharedPreferenceChanged(prefs, null);
		// paneb volminupu
		setVolumeControlStream(AudioManager.STREAM_MUSIC);
		// lingid
		progressBar = (ProgressBar) findViewById(R.id.progressBar1);
		textView = (TextView) findViewById(R.id.textView1);

		listView = (ListView) findViewById(R.id.listUuudised);
		listView.setTextFilterEnabled(false);

		listView.setOnItemClickListener(new ListView.OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> a, View v, int ji, long l) {
				try {
					if (!downloading) {
						playing = true;
						downloading = true;

						textView.setText(getString(R.string.loading_news));
						new DownloadMP3Task()
								.execute("http://elte.eki.ee/cgi-bin/ekinews.cgi?z=see&q="
										+ l + "&v=" + pref_v + "&s=" + pref_s);
						dBh.markAsReadID(ji);
						setupList();
					}
					// Remembers the selected Index
					// listView = listView.getSelectedItemPosition();
				} catch (Exception e) {
					System.out.println("Nay, cannot get the selected index");
				}
			}
		});

		dBh = new UDBh(this);

		// on resume !!!

	}

	@Override
	protected void onPause() {
		super.onPause();
		playing = false;
		handler.removeCallbacks(UpdatePlayerStats);
		wl.release();
		if (mediaPlayer != null) {
			mediaPlayer.stop();
			mediaPlayer.release();

			mediaPlayer = null;
		}

	}

	@Override
	protected void onResume() {
		super.onResume();
		new DownloadListTask().execute("ok");
	}

	private void setupList() {

		// Get the top position from the first visible element
		int idx = listView.getFirstVisiblePosition();
		View vfirst = listView.getChildAt(0);
		int pos = 0;
		if (vfirst != null)
			pos = vfirst.getTop();

		listView.setAdapter(dBh.getAdapter());

		// Restore the position
		listView.setSelectionFromTop(idx, pos);

	}

	private void clearCacheFolder() {
		final File dir = getCacheDir();
		try {
			for (File child : dir.listFiles()) {
				if (child.getName().endsWith("mp3")) {
					if (child.lastModified() < new Date().getTime()
							- DateUtils.MINUTE_IN_MILLIS) {
						if (child.delete()) {
						}
					}
				}
			}
		} catch (Exception e) {
			Log.e("cace err",
					String.format("Failed to clean the cache, error %s",
							e.getMessage()));
		}

	}

	private void updateLista() {
		HTTPtoBase("http://elte.eki.ee/cgi-bin/ekinews.cgi?z=sisukord&q="
				+ dBh.getLatestStatusCreatedAtTime());
		// Puhasta vanadest
		dBh.cleanUp();
	}

	public void onNext(View v) {
		if (playNext) {
			playNext = false;
		} else {
			playNext = true;
		}
		SetBtns();

	}

	public void onPlay(View v) {
		PlayPause();
		SetBtns();

	}

	public void SetBtns() {
		// play
		Button btn = (Button) findViewById(R.id.button1);
		if (playing) {
			btn.setText(getString(R.string.Pause_news));
		} else {
			btn.setText(getString(R.string.Play_news));
		}

		// play
		Button btn2 = (Button) findViewById(R.id.button2);
		if (playNext) {
			btn2.setText(getString(R.string.Next_news));
		} else {
			btn2.setText(getString(R.string.NoNext_news));
		}

	}

	public void onStop(View v) {
		if (mediaPlayer != null) {
			mediaPlayer.pause();
			mediaPlayer.seekTo(0);
		}
		playing = false;
		wl.release();
	}

	private class DownloadMP3Task extends AsyncTask<String, Integer, File> {
		protected File doInBackground(String... urls) {
			File out = null;
			for (int i = 0; i < 4; i++) {
				System.out.println("[Jama] prooviL ," + urls[0]);
				out = HTTPtoFile(urls[0]);
				if (out != null)
					break;
			}
			return out;
		}

		protected void onProgressUpdate(Integer... progress) {
			// setProgressPercent(progress[0]);
		}

		protected void onPostExecute(File result) {
			if (mediaPlayer != null) {
				mediaPlayer.release();
				mediaPlayer = null;
			}
			playMp3(result);
			SetBtns();
			downloading = false;
		}

	}

	private class DownloadListTask extends AsyncTask<String, Integer, File> {
		protected File doInBackground(String... urls) {
			clearCacheFolder();
			updateLista();
			return null;
		}

		protected void onProgressUpdate(Integer... progress) {
			// setProgressPercent(progress[0]);
		}

		protected void onPostExecute(File result) {
			textView.setText(getString(R.string.list_loaded));
			downloading = false;
			setupList();
		}

	}

	Runnable UpdatePlayerStats = new Runnable() {
		@Override
		public void run() {
			if (mediaPlayer != null) {
				if (mediaPlayer.getDuration() > 0) {
					progressBar.setProgress((int) (mediaPlayer
							.getCurrentPosition() * 100 / mediaPlayer
							.getDuration()));
					int aeg = mediaPlayer.getCurrentPosition() / 1000;
					int taeg = mediaPlayer.getDuration() / 1000;

					textView.setText("" + (aeg / 60) + ":" + (aeg % 60) + " / "
							+ (taeg / 60) + ":" + (taeg % 60));
				}
			}
			if (playing) {

				if (!mediaPlayer.isPlaying()) {
					if (playNext) {
						if (!downloading) {

							downloading = true;
							progressBar.setProgress(100);
							SetBtns();
							long l = dBh.getLatestNewsNotReaded();
							textView.setText(getString(R.string.loading_news));
							new DownloadMP3Task()
									.execute("http://elte.eki.ee/cgi-bin/ekinews.cgi?z=see&q="
											+ l
											+ "&v="
											+ pref_v
											+ "&s="
											+ pref_s);
							dBh.markAsRead(l);
							setupList();
						}
					}
				} else {
					handler.postDelayed(UpdatePlayerStats, 500);
				}

			} else {

			}
		}
	};

	public void PlayPause() {
		if (mediaPlayer != null) {
			if (mediaPlayer.isPlaying()) {
				mediaPlayer.pause();
				handler.removeCallbacks(UpdatePlayerStats);
				playing = false;
				wl.release();
			} else {
				mediaPlayer.start();
				playing = true;
				handler.removeCallbacks(UpdatePlayerStats);
				handler.postDelayed(UpdatePlayerStats, 100);
				wl.acquire();
			}
		} else {
			// kui pole veel valitud
			if (!downloading) {

				downloading = true;

				SetBtns();
				long l = dBh.getLatestNewsNotReaded();
				textView.setText(getString(R.string.loading_news));
				new DownloadMP3Task()
						.execute("http://elte.eki.ee/cgi-bin/ekinews.cgi?z=see&q="
								+ l + "&v=" + pref_v + "&s=" + pref_s);
				dBh.markAsRead(l);
				setupList();
			}

		}
	}

	private void playMp3(File tempMp3) {
		if (mediaPlayer != null) {
			mediaPlayer.release();
		}

		// teata kasutajat ka...
		try {
			mediaPlayer = new MediaPlayer();
			FileInputStream fis = new FileInputStream(tempMp3);
			mediaPlayer.setDataSource(fis.getFD());
			mediaPlayer.prepare();
			textView.setText(getString(R.string.main_loaded));
			if (playing) {
				// mediaPlayer.seekTo(0);
				mediaPlayer.start();

				handler.removeCallbacks(UpdatePlayerStats);
				handler.postDelayed(UpdatePlayerStats, 100);
				wl.acquire();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}

	}

	private synchronized int HTTPtoBase(String urla) {
		try {
			URL url = new URL(urla);

			BufferedReader in = new BufferedReader(new InputStreamReader(
					url.openStream()));

			int out = 0;

			dBh.readFromBuffer(in, true);
			dBh.save();
			//dBh.load();
			
			in.close();

			return out;

		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return 0;
	}

	private synchronized File HTTPtoFile(String urla) {
		try {
			URL url = new URL(urla);

			HttpURLConnection urlConnection = (HttpURLConnection) url
					.openConnection();
			urlConnection.setRequestMethod("GET");
			// urlConnection.setDoOutput(true);
			urlConnection.connect();

			InputStream inputStream = urlConnection.getInputStream();

			// int totalSize = urlConnection.getContentLength();
			pref_jarg = urlConnection.getHeaderFieldInt("Nupp", 0);

			SharedPreferences.Editor prefsave = prefs.edit();
			prefsave.putInt("jarg", pref_jarg);
			prefsave.commit();

			byte[] buffer = new byte[1024];
			inputStream.read(buffer);
System.out.println("[----] HTTP TO FILE = ," + getCacheDir());
			File tempMp3 = File.createTempFile("news", "mp3", getCacheDir());
			
			tempMp3.deleteOnExit();
			FileOutputStream fos = new FileOutputStream(tempMp3);
			int len1;
			while ((len1 = inputStream.read(buffer)) > 0) {
				fos.write(buffer, 0, len1);
			}

			fos.close();
			inputStream.close();
			return tempMp3;

		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("[Jama] HTTP TO FILE = NULL ," + urla);
		return null;
	}

	void ST(String a) {
		CharSequence text = a;
		System.out.println("[TOAST] " + a);
		Toast toast = Toast.makeText(getApplicationContext(), text,
				Toast.LENGTH_SHORT);
		toast.show();

	}

	@Override
	public void onSharedPreferenceChanged(SharedPreferences prefs, String key) {
		pref_v = prefs.getString("v", "1");
		pref_s = prefs.getString("s", "1");
		pref_jarg = prefs.getInt("jarg", 1);

	}

	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.run_prefs:
			startActivity(new Intent(this, Prefs.class));
			break;
		case R.id.run_about:
			startActivityForResult(new Intent(this, About.class), 0);
			break;
		}
		return true;
	}
}