package ee.eki.news;

import java.util.List;

import android.content.Context;
import android.graphics.Color;
import android.text.format.DateUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class UAdapder extends ArrayAdapter<NewsItem> {
	private final Context context;
	private final List<NewsItem> objects;

	public UAdapder(Context context, int textViewResourceId, List<NewsItem> objects) {
		super(context, textViewResourceId, objects);
		this.context = context;
		this.objects = objects;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View rowView = convertView;
		UudiseView sqView = null;

		if (rowView == null) {
			LayoutInflater inflater = ((EKINewsActivity) context)
					.getLayoutInflater();
			rowView = inflater.inflate(R.layout.rida, null);

			sqView = new UudiseView();
			sqView.aeg = (TextView) rowView.findViewById(R.id.textCreatedAt);
			sqView.uudis = (TextView) rowView.findViewById(R.id.textText);

			rowView.setTag(sqView);
		} else {
			sqView = (UudiseView) rowView.getTag();
		}

		NewsItem cr = (NewsItem) objects.get(position);
		// uudis ise
		sqView.uudis.setText(cr.getUudis());
		// aeg
		long timestamp = cr.getId();

		rowView.setId((int) timestamp);
		
		CharSequence relTime = DateUtils.getRelativeTimeSpanString(
				timestamp * 1000, System.currentTimeMillis(),
				DateUtils.MINUTE_IN_MILLIS, DateUtils.FORMAT_ABBREV_RELATIVE);
		sqView.aeg.setText(relTime);
		// taust
		if (cr.getLoetud() == 1) {
			rowView.setBackgroundColor(Color.argb(255, 30, 30, 30));
		} else {
			rowView.setBackgroundColor(Color.argb(255, 0, 0, 0));
		}

		return rowView;
	}

	@Override
	public long getItemId(int position) {
	   
	    return objects.get(position).getId();
	}

	
	protected static class UudiseView {
		protected TextView aeg;
		protected TextView uudis;
	}
}
