package ee.eki.news;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import android.widget.ListAdapter;

public class UDBh {

	private EKINewsActivity ekiNewsActivity;
	private List<NewsItem> newsList = new ArrayList<NewsItem>();
	private Long newest = 1L;
	private UAdapder adapder;

	private final String dataFileName = "ekinews.txt";
	private File dataFile;

	public UDBh(EKINewsActivity ekiNewsActivity) {
		this.ekiNewsActivity = ekiNewsActivity;
		adapder = new UAdapder(ekiNewsActivity, R.layout.rida, newsList);
		dataFile = new File(ekiNewsActivity.getFilesDir(), dataFileName);
		load();
	}

	private void readListFile(File f) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(f));
		readFromBuffer(in, false);
		in.close();
	}

	private void writeListFile(File installation) throws IOException {
		FileOutputStream out = new FileOutputStream(installation);
		String data = "";
		NewsItem u;
		for (int i =  newsList.size()-1; i >= 0; i--) {
			u = newsList.get(i);
			data = u.toStringOut() + "\n";
			out.write(data.getBytes());
		}
		out.close();
	}

	/**
	 * @param id
	 *            jrjekorranumber
	 */
	public void markAsReadID(int id) {
		newsList.get(id).setReaded(1);
		save();
	}

	/**
	 * @param time
	 *            aeg
	 */
	public void markAsRead(long time) {
		NewsItem u;
		for (int i = 0; i < newsList.size(); i++) {
			u = newsList.get(i);
			if (u.getId() == time) {
				u.setReaded(1);
				break;
			}
		}
		save();
	}

	public long getLatestNewsNotReaded() {
		NewsItem u;
		for (int i = 0; i < newsList.size(); i++) {
			u = newsList.get(i);
			if (u.getLoetud() != 1) {
				return u.getId();
			}
		}
		return 0;
	}

	public void cleanUp() {
		if (newsList.size() > 100) {
			for (int i = 101; i < newsList.size(); i++) {
				newsList.remove(i);
			}
		}
		save();
	}

	public int newsExists(double aeg) {
		NewsItem u;
		for (int i = 0; i < newsList.size(); i++) {
			u = newsList.get(i);
			if (u.getId() == aeg) {
				return i;
			}
		}
		return -1;
	}

	public String getLatestStatusCreatedAtTime() {
		return newest.toString();
	}

	public void save() {
		synchronized (dataFile) {
			try {
				writeListFile(dataFile);
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}
	}

	public void load() {
		synchronized (dataFile) {
			try {
				if (dataFile.exists())
					readListFile(dataFile);
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}

	}

	/**
	 * @param in
	 *            loetav buffer kus uudised on ridadekaupa
	 * @param serverist
	 *            false- kui laetakse failist, internetis puudub vli juba
	 *            loetute mrkimiseks
	 * @throws IOException
	 */
	public void readFromBuffer(BufferedReader in, boolean serverist)
			throws IOException {
		String str;

		NewsItem u;
		while ((str = in.readLine()) != null) {
			if (serverist) {
				str = "0\t" + str; // et ei ole loetud
			}
			u = new NewsItem(str);
			
			//if(uudisExists(u.getId())==-1){
				if(u.getId()>newest){
					newest =u.getId(); 
				}
				newsList.add(0, u);
			// }
		}

	}

	public ListAdapter getAdapter() {
		return adapder;
	}

}
